/* xnoise-mpris.c generated by valac 0.11.7, the Vala compiler
 * generated from xnoise-mpris.vala, do not modify */

/* xnoise-mpris.vala
 *
 * Copyright (C) 2010 Andreas Obergrusberger
 * Copyright (C) 2010 - 2011 Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 * Andreas Obergrusberger
 * Jörn Magens
 */
/* exposes xnoise's player and tracklist controls via dbus using the mpris v2 interface*/
/* refer to */
/* http://www.mpris.org/2.0/spec/*/

#include <glib.h>
#include <glib-object.h>
#include <xnoise.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>


#define XNOISE_TYPE_MPRIS (xnoise_mpris_get_type ())
#define XNOISE_MPRIS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_MPRIS, XnoiseMpris))
#define XNOISE_MPRIS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_MPRIS, XnoiseMprisClass))
#define XNOISE_IS_MPRIS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_MPRIS))
#define XNOISE_IS_MPRIS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_MPRIS))
#define XNOISE_MPRIS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_MPRIS, XnoiseMprisClass))

typedef struct _XnoiseMpris XnoiseMpris;
typedef struct _XnoiseMprisClass XnoiseMprisClass;
typedef struct _XnoiseMprisPrivate XnoiseMprisPrivate;

#define TYPE_MPRIS_PLAYER (mpris_player_get_type ())
#define MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_PLAYER, MprisPlayer))
#define MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_PLAYER, MprisPlayerClass))
#define IS_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_PLAYER))
#define IS_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_PLAYER))
#define MPRIS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_PLAYER, MprisPlayerClass))

typedef struct _MprisPlayer MprisPlayer;
typedef struct _MprisPlayerClass MprisPlayerClass;

#define TYPE_MPRIS_ROOT (mpris_root_get_type ())
#define MPRIS_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_ROOT, MprisRoot))
#define MPRIS_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_ROOT, MprisRootClass))
#define IS_MPRIS_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_ROOT))
#define IS_MPRIS_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_ROOT))
#define MPRIS_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_ROOT, MprisRootClass))

typedef struct _MprisRoot MprisRoot;
typedef struct _MprisRootClass MprisRootClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MprisRootPrivate MprisRootPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MprisPlayerPrivate MprisPlayerPrivate;

#define MPRIS_PLAYER_TYPE_DIRECTION (mpris_player_direction_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

struct _XnoiseMpris {
	GObject parent_instance;
	XnoiseMprisPrivate * priv;
	MprisPlayer* player;
	MprisRoot* root;
};

struct _XnoiseMprisClass {
	GObjectClass parent_class;
};

struct _XnoiseMprisPrivate {
	XnoiseMain* _xn;
	guint owner_id;
	guint object_id_root;
	guint object_id_player;
	XnoisePlugin* _owner;
	GDBusConnection* conn;
};

struct _MprisRoot {
	GObject parent_instance;
	MprisRootPrivate * priv;
};

struct _MprisRootClass {
	GObjectClass parent_class;
};

struct _MprisRootPrivate {
	XnoiseMain* xn;
};

struct _MprisPlayer {
	GObject parent_instance;
	MprisPlayerPrivate * priv;
};

struct _MprisPlayerClass {
	GObjectClass parent_class;
};

struct _MprisPlayerPrivate {
	XnoiseMain* xn;
	GDBusConnection* conn;
	guint send_property_source;
	guint update_metadata_source;
	GHashTable* changed_properties;
	XnoiseMainWindowPlayerRepeatMode buffer_repeat_state;
	GHashTable* _metadata;
};

typedef enum  {
	MPRIS_PLAYER_DIRECTION_NEXT = 0,
	MPRIS_PLAYER_DIRECTION_PREVIOUS,
	MPRIS_PLAYER_DIRECTION_STOP
} MprisPlayerDirection;


static gpointer xnoise_mpris_parent_class = NULL;
static XnoiseIPluginIface* xnoise_mpris_xnoise_iplugin_parent_iface = NULL;
static GType xnoise_mpris_type_id = 0;
static gpointer mpris_root_parent_class = NULL;
static GType mpris_root_type_id = 0;
static gpointer mpris_player_parent_class = NULL;
static GType mpris_player_type_id = 0;

GType xnoise_mpris_get_type (void) G_GNUC_CONST;
GType xnoise_mpris_register_type (GTypeModule * module);
GType mpris_player_get_type (void) G_GNUC_CONST;
GType mpris_player_register_type (GTypeModule * module);
guint mpris_player_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType mpris_root_get_type (void) G_GNUC_CONST;
GType mpris_root_register_type (GTypeModule * module);
guint mpris_root_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
#define XNOISE_MPRIS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_MPRIS, XnoiseMprisPrivate))
enum  {
	XNOISE_MPRIS_DUMMY_PROPERTY,
	XNOISE_MPRIS_XN,
	XNOISE_MPRIS_OWNER,
	XNOISE_MPRIS_NAME
};
static void xnoise_mpris_on_bus_acquired (XnoiseMpris* self, GDBusConnection* connection, const gchar* name);
MprisRoot* mpris_root_new (void);
MprisRoot* mpris_root_construct (GType object_type);
MprisPlayer* mpris_player_new (GDBusConnection* conn);
MprisPlayer* mpris_player_construct (GType object_type, GDBusConnection* conn);
static void xnoise_mpris_on_name_acquired (XnoiseMpris* self, GDBusConnection* connection, const gchar* name);
static void xnoise_mpris_on_name_lost (XnoiseMpris* self, GDBusConnection* connection, const gchar* name);
static gboolean xnoise_mpris_real_init (XnoiseIPlugin* base);
static void _xnoise_mpris_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void _xnoise_mpris_on_name_lost_gbus_name_lost_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void xnoise_mpris_clean_up (XnoiseMpris* self);
static void _xnoise_mpris_clean_up_xnoise_plugin_sign_deactivated (XnoisePlugin* _sender, gpointer self);
static void xnoise_mpris_real_uninit (XnoiseIPlugin* base);
static GtkWidget* xnoise_mpris_real_get_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_mpris_real_has_settings_widget (XnoiseIPlugin* base);
XnoiseMpris* xnoise_mpris_new (void);
XnoiseMpris* xnoise_mpris_construct (GType object_type);
static void xnoise_mpris_finalize (GObject* obj);
static void _vala_xnoise_mpris_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_xnoise_mpris_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define MPRIS_ROOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MPRIS_ROOT, MprisRootPrivate))
enum  {
	MPRIS_ROOT_DUMMY_PROPERTY,
	MPRIS_ROOT_CAN_QUIT,
	MPRIS_ROOT_CAN_RAISE,
	MPRIS_ROOT_HAS_TRACK_LIST,
	MPRIS_ROOT_DESKTOP_ENTRY,
	MPRIS_ROOT_IDENTITY,
	MPRIS_ROOT_SUPPORTED_URI_SCHEMES,
	MPRIS_ROOT_SUPPORTED_MIME_TYPES
};
void mpris_root_Quit (MprisRoot* self);
void mpris_root_Raise (MprisRoot* self);
gboolean mpris_root_get_CanQuit (MprisRoot* self);
gboolean mpris_root_get_CanRaise (MprisRoot* self);
gboolean mpris_root_get_HasTrackList (MprisRoot* self);
gchar* mpris_root_get_DesktopEntry (MprisRoot* self);
gchar* mpris_root_get_Identity (MprisRoot* self);
gchar** mpris_root_get_SupportedUriSchemes (MprisRoot* self, int* result_length1);
gchar** mpris_root_get_SupportedMimeTypes (MprisRoot* self, int* result_length1);
static void mpris_root_finalize (GObject* obj);
static void _vala_mpris_root_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _dbus_mpris_root_Quit (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_root_Raise (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void mpris_root_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* mpris_root_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_mpris_root_get_CanQuit (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_CanRaise (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_HasTrackList (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_DesktopEntry (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_Identity (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_SupportedUriSchemes (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_SupportedMimeTypes (MprisRoot* self);
static gboolean mpris_root_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _mpris_root_unregister_object (gpointer user_data);
#define MPRIS_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MPRIS_PLAYER, MprisPlayerPrivate))
enum  {
	MPRIS_PLAYER_DUMMY_PROPERTY,
	MPRIS_PLAYER_PLAYBACK_STATUS,
	MPRIS_PLAYER_LOOP_STATUS,
	MPRIS_PLAYER_RATE,
	MPRIS_PLAYER_SHUFFLE,
	MPRIS_PLAYER_METADATA,
	MPRIS_PLAYER_VOLUME,
	MPRIS_PLAYER_POSITION,
	MPRIS_PLAYER_MINIMUM_RATE,
	MPRIS_PLAYER_MAXIMUM_RATE,
	MPRIS_PLAYER_CAN_GO_NEXT,
	MPRIS_PLAYER_CAN_GO_PREVIOUS,
	MPRIS_PLAYER_CAN_PLAY,
	MPRIS_PLAYER_CAN_PAUSE,
	MPRIS_PLAYER_CAN_SEEK,
	MPRIS_PLAYER_CAN_CONTROL
};
static GType mpris_player_direction_get_type (void) G_GNUC_UNUSED;
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
#define MPRIS_PLAYER_INTERFACE_NAME "org.mpris.MediaPlayer2.Player"
static gboolean _lambda0_ (MprisPlayer* self);
static GVariant* _variant_new1 (const gchar* value);
static void mpris_player_queue_property_for_notification (MprisPlayer* self, const gchar* property, GVariant* val);
static gboolean _lambda1_ (MprisPlayer* self);
static GVariant* _variant_new2 (const gchar* value);
static gboolean __lambda1__gsource_func (gpointer self);
static gboolean __lambda0__gsource_func (gpointer self);
static void _lambda2_ (GObject* s, GParamSpec* p, MprisPlayer* self);
gchar* mpris_player_get_PlaybackStatus (MprisPlayer* self);
static GVariant* _variant_new3 (gchar* value);
static void __lambda2__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void mpris_player_on_tag_changed (MprisPlayer* self, XnoiseGlobalAccess* sender, gchar** newuri, const gchar* tagname, const gchar* tagvalue);
static void _mpris_player_on_tag_changed_xnoise_global_access_tag_changed (XnoiseGlobalAccess* _sender, gchar** newuri, const gchar* tagname, const gchar* tagvalue, gpointer self);
static void _lambda4_ (MprisPlayer* self);
static GVariant* _variant_new4 (gdouble value);
static void __lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _lambda5_ (MprisPlayer* self);
static GVariant* _variant_new5 (const gchar* value);
static GVariant* _variant_new6 (gchar* value);
static GVariant* _variant_new7 (const gchar* value);
static void mpris_player_trigger_metadata_update (MprisPlayer* self);
static void __lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _lambda6_ (MprisPlayer* self);
static GVariant* _variant_new8 (gint64 value);
static gint64 _variant_get9 (GVariant* value);
static GVariant* _variant_new10 (gint64 value);
static void __lambda6__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static gboolean _lambda3_ (MprisPlayer* self);
static GVariant* _variant_new11 (GHashTable* value);
static gboolean __lambda3__gsource_func (gpointer self);
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value);
static GVariant* _variant_new12 (gchar** value, gint value_length1);
static GVariant* _variant_new13 (const gchar* value);
static GVariant* _variant_new14 (const gchar* value);
static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value);
static GVariant* _variant_new15 (gchar** value, gint value_length1);
static gboolean mpris_player_send_property_change (MprisPlayer* self);
static gboolean _mpris_player_send_property_change_gsource_func (gpointer self);
void mpris_player_Next (MprisPlayer* self);
void mpris_player_Previous (MprisPlayer* self);
void mpris_player_Pause (MprisPlayer* self);
void mpris_player_PlayPause (MprisPlayer* self);
void mpris_player_Stop (MprisPlayer* self);
void mpris_player_Play (MprisPlayer* self);
void mpris_player_Seek (MprisPlayer* self, gint64 Offset);
void mpris_player_SetPosition (MprisPlayer* self, const gchar* dobj, gint64 Position);
void mpris_player_OpenUri (MprisPlayer* self, const gchar* Uri);
gchar* mpris_player_get_LoopStatus (MprisPlayer* self);
void mpris_player_set_LoopStatus (MprisPlayer* self, const gchar* value);
static GVariant* _variant_new16 (const gchar* value);
gdouble mpris_player_get_Rate (MprisPlayer* self);
void mpris_player_set_Rate (MprisPlayer* self, gdouble value);
gboolean mpris_player_get_Shuffle (MprisPlayer* self);
void mpris_player_set_Shuffle (MprisPlayer* self, gboolean value);
static GVariant* _variant_new17 (gboolean value);
GHashTable* mpris_player_get_Metadata (MprisPlayer* self);
static GVariant* _variant_new18 (const gchar* value);
gdouble mpris_player_get_Volume (MprisPlayer* self);
void mpris_player_set_Volume (MprisPlayer* self, gdouble value);
gint64 mpris_player_get_Position (MprisPlayer* self);
gdouble mpris_player_get_MinimumRate (MprisPlayer* self);
gdouble mpris_player_get_MaximumRate (MprisPlayer* self);
gboolean mpris_player_get_CanGoNext (MprisPlayer* self);
gboolean mpris_player_get_CanGoPrevious (MprisPlayer* self);
gboolean mpris_player_get_CanPlay (MprisPlayer* self);
gboolean mpris_player_get_CanPause (MprisPlayer* self);
gboolean mpris_player_get_CanSeek (MprisPlayer* self);
gboolean mpris_player_get_CanControl (MprisPlayer* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void mpris_player_finalize (GObject* obj);
static void _vala_mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _dbus_mpris_player_Next (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Previous (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Pause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_PlayPause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Stop (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Play (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_Seek (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_SetPosition (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_OpenUri (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_mpris_player_get_PlaybackStatus (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_LoopStatus (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Rate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Shuffle (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Metadata (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Volume (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_Position (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_MinimumRate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_MaximumRate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanGoNext (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanGoPrevious (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanPlay (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanPause (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanSeek (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_CanControl (MprisPlayer* self);
static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_mpris_player_set_LoopStatus (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Rate (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Shuffle (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_Volume (MprisPlayer* self, GVariant* _value);
static void _dbus_mpris_player_seeked (GObject* _sender, gint64 Position, gpointer* _data);
static void _mpris_player_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Quit_in[] = {NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Quit_out[] = {NULL};
static const GDBusMethodInfo _mpris_root_dbus_method_info_Quit = {-1, "Quit", (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Quit_in), (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Quit_out)};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Raise_in[] = {NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_Raise_out[] = {NULL};
static const GDBusMethodInfo _mpris_root_dbus_method_info_Raise = {-1, "Raise", (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Raise_in), (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_Raise_out)};
static const GDBusMethodInfo * const _mpris_root_dbus_method_info[] = {&_mpris_root_dbus_method_info_Quit, &_mpris_root_dbus_method_info_Raise, NULL};
static const GDBusSignalInfo * const _mpris_root_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_CanQuit = {-1, "CanQuit", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_CanRaise = {-1, "CanRaise", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_HasTrackList = {-1, "HasTrackList", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_DesktopEntry = {-1, "DesktopEntry", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_Identity = {-1, "Identity", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_SupportedUriSchemes = {-1, "SupportedUriSchemes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_SupportedMimeTypes = {-1, "SupportedMimeTypes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _mpris_root_dbus_property_info[] = {&_mpris_root_dbus_property_info_CanQuit, &_mpris_root_dbus_property_info_CanRaise, &_mpris_root_dbus_property_info_HasTrackList, &_mpris_root_dbus_property_info_DesktopEntry, &_mpris_root_dbus_property_info_Identity, &_mpris_root_dbus_property_info_SupportedUriSchemes, &_mpris_root_dbus_property_info_SupportedMimeTypes, NULL};
static const GDBusInterfaceInfo _mpris_root_dbus_interface_info = {-1, "org.mpris.MediaPlayer2", (GDBusMethodInfo **) (&_mpris_root_dbus_method_info), (GDBusSignalInfo **) (&_mpris_root_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_root_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_root_dbus_interface_vtable = {mpris_root_dbus_interface_method_call, mpris_root_dbus_interface_get_property, mpris_root_dbus_interface_set_property};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Next_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Next_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Next = {-1, "Next", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Next_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Next_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Previous_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Previous_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Previous = {-1, "Previous", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Previous_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Previous_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Pause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Pause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Pause = {-1, "Pause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Pause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Pause_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_PlayPause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_PlayPause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_PlayPause = {-1, "PlayPause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_PlayPause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_PlayPause_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Stop_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Stop_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Stop = {-1, "Stop", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Stop_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Stop_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Play_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Play_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Play = {-1, "Play", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Play_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Play_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_Seek_Offset = {-1, "Offset", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Seek_in[] = {&_mpris_player_dbus_arg_info_Seek_Offset, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_Seek_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_Seek = {-1, "Seek", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Seek_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_Seek_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_SetPosition_dobj = {-1, "dobj", "s"};
static const GDBusArgInfo _mpris_player_dbus_arg_info_SetPosition_Position = {-1, "Position", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_SetPosition_in[] = {&_mpris_player_dbus_arg_info_SetPosition_dobj, &_mpris_player_dbus_arg_info_SetPosition_Position, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_SetPosition_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_SetPosition = {-1, "SetPosition", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_SetPosition_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_SetPosition_out)};
static const GDBusArgInfo _mpris_player_dbus_arg_info_OpenUri_Uri = {-1, "Uri", "s"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_OpenUri_in[] = {&_mpris_player_dbus_arg_info_OpenUri_Uri, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_OpenUri_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_OpenUri = {-1, "OpenUri", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_OpenUri_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_OpenUri_out)};
static const GDBusMethodInfo * const _mpris_player_dbus_method_info[] = {&_mpris_player_dbus_method_info_Next, &_mpris_player_dbus_method_info_Previous, &_mpris_player_dbus_method_info_Pause, &_mpris_player_dbus_method_info_PlayPause, &_mpris_player_dbus_method_info_Stop, &_mpris_player_dbus_method_info_Play, &_mpris_player_dbus_method_info_Seek, &_mpris_player_dbus_method_info_SetPosition, &_mpris_player_dbus_method_info_OpenUri, NULL};
static const GDBusArgInfo _mpris_player_dbus_arg_info_seeked_Position = {-1, "Position", "x"};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_seeked[] = {&_mpris_player_dbus_arg_info_seeked_Position, NULL};
static const GDBusSignalInfo _mpris_player_dbus_signal_info_seeked = {-1, "Seeked", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_seeked)};
static const GDBusSignalInfo * const _mpris_player_dbus_signal_info[] = {&_mpris_player_dbus_signal_info_seeked, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_PlaybackStatus = {-1, "PlaybackStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_LoopStatus = {-1, "LoopStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Rate = {-1, "Rate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Shuffle = {-1, "Shuffle", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Metadata = {-1, "Metadata", "a{sv}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Volume = {-1, "Volume", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_Position = {-1, "Position", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_MinimumRate = {-1, "MinimumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_MaximumRate = {-1, "MaximumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanGoNext = {-1, "CanGoNext", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanGoPrevious = {-1, "CanGoPrevious", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanPlay = {-1, "CanPlay", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanPause = {-1, "CanPause", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanSeek = {-1, "CanSeek", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_CanControl = {-1, "CanControl", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _mpris_player_dbus_property_info[] = {&_mpris_player_dbus_property_info_PlaybackStatus, &_mpris_player_dbus_property_info_LoopStatus, &_mpris_player_dbus_property_info_Rate, &_mpris_player_dbus_property_info_Shuffle, &_mpris_player_dbus_property_info_Metadata, &_mpris_player_dbus_property_info_Volume, &_mpris_player_dbus_property_info_Position, &_mpris_player_dbus_property_info_MinimumRate, &_mpris_player_dbus_property_info_MaximumRate, &_mpris_player_dbus_property_info_CanGoNext, &_mpris_player_dbus_property_info_CanGoPrevious, &_mpris_player_dbus_property_info_CanPlay, &_mpris_player_dbus_property_info_CanPause, &_mpris_player_dbus_property_info_CanSeek, &_mpris_player_dbus_property_info_CanControl, NULL};
static const GDBusInterfaceInfo _mpris_player_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Player", (GDBusMethodInfo **) (&_mpris_player_dbus_method_info), (GDBusSignalInfo **) (&_mpris_player_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_player_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_player_dbus_interface_vtable = {mpris_player_dbus_interface_method_call, mpris_player_dbus_interface_get_property, mpris_player_dbus_interface_set_property};

static void xnoise_mpris_on_bus_acquired (XnoiseMpris* self, GDBusConnection* connection, const gchar* name) {
	MprisRoot* _tmp0_ = NULL;
	MprisPlayer* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
	self->priv->conn = connection;
	_tmp0_ = mpris_root_new ();
	_g_object_unref0 (self->root);
	self->root = _tmp0_;
	mpris_root_register_object (self->root, connection, "/org/mpris/MediaPlayer2", &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch0_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp1_ = mpris_player_new (connection);
	_g_object_unref0 (self->player);
	self->player = _tmp1_;
	mpris_player_register_object (self->player, connection, "/org/mpris/MediaPlayer2", &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch0_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_print ("%s\n", e->message);
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void xnoise_mpris_on_name_acquired (XnoiseMpris* self, GDBusConnection* connection, const gchar* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
}


static void xnoise_mpris_on_name_lost (XnoiseMpris* self, GDBusConnection* connection, const gchar* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
}


static void _xnoise_mpris_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	xnoise_mpris_on_bus_acquired (self, connection, name);
}


static void _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	xnoise_mpris_on_name_acquired (self, connection, name);
}


static void _xnoise_mpris_on_name_lost_gbus_name_lost_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	xnoise_mpris_on_name_lost (self, connection, name);
}


static void _xnoise_mpris_clean_up_xnoise_plugin_sign_deactivated (XnoisePlugin* _sender, gpointer self) {
	xnoise_mpris_clean_up (self);
}


static gboolean xnoise_mpris_real_init (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	guint _tmp0_;
	XnoisePlugin* _tmp1_ = NULL;
	self = (XnoiseMpris*) base;
	_tmp0_ = g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, "org.mpris.MediaPlayer2.xnoise", G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((_xnoise_mpris_on_bus_acquired_gbus_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_mpris_on_bus_acquired_gbus_acquired_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_xnoise_mpris_on_name_acquired_gbus_name_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_mpris_on_name_acquired_gbus_name_acquired_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_xnoise_mpris_on_name_lost_gbus_name_lost_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_mpris_on_name_lost_gbus_name_lost_callback, g_object_ref (self), g_object_unref)));
	self->priv->owner_id = _tmp0_;
	if (self->priv->owner_id == 0) {
		g_print ("mpris error\n");
		result = FALSE;
		return result;
	}
	_tmp1_ = xnoise_iplugin_get_owner ((XnoiseIPlugin*) self);
	g_signal_connect_object (_tmp1_, "sign-deactivated", (GCallback) _xnoise_mpris_clean_up_xnoise_plugin_sign_deactivated, self, 0);
	result = TRUE;
	return result;
}


static void xnoise_mpris_real_uninit (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	self = (XnoiseMpris*) base;
	xnoise_mpris_clean_up (self);
}


static void xnoise_mpris_clean_up (XnoiseMpris* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->owner_id == 0) {
		return;
	}
	g_dbus_connection_unregister_object (self->priv->conn, self->priv->object_id_player);
	g_dbus_connection_unregister_object (self->priv->conn, self->priv->object_id_root);
	g_bus_unown_name (self->priv->owner_id);
	self->priv->object_id_player = (guint) 0;
	self->priv->object_id_root = (guint) 0;
	self->priv->owner_id = (guint) 0;
}


static GtkWidget* xnoise_mpris_real_get_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	GtkWidget* result = NULL;
	self = (XnoiseMpris*) base;
	result = NULL;
	return result;
}


static gboolean xnoise_mpris_real_has_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	self = (XnoiseMpris*) base;
	result = FALSE;
	return result;
}


XnoiseMpris* xnoise_mpris_construct (GType object_type) {
	XnoiseMpris * self = NULL;
	self = (XnoiseMpris*) g_object_new (object_type, NULL);
	return self;
}


XnoiseMpris* xnoise_mpris_new (void) {
	return xnoise_mpris_construct (XNOISE_TYPE_MPRIS);
}


static XnoiseMain* xnoise_mpris_real_get_xn (XnoiseIPlugin* base) {
	XnoiseMain* result;
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	result = self->priv->_xn;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void xnoise_mpris_real_set_xn (XnoiseIPlugin* base, XnoiseMain* value) {
	XnoiseMpris* self;
	XnoiseMain* _tmp0_;
	self = (XnoiseMpris*) base;
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_xn);
	self->priv->_xn = _tmp0_;
	g_object_notify ((GObject *) self, "xn");
}


static XnoisePlugin* xnoise_mpris_real_get_owner (XnoiseIPlugin* base) {
	XnoisePlugin* result;
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	result = self->priv->_owner;
	return result;
}


static void xnoise_mpris_real_set_owner (XnoiseIPlugin* base, XnoisePlugin* value) {
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	self->priv->_owner = value;
	g_object_notify ((GObject *) self, "owner");
}


static const gchar* xnoise_mpris_real_get_name (XnoiseIPlugin* base) {
	const gchar* result;
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	result = "mpris";
	return result;
}


static void xnoise_mpris_class_init (XnoiseMprisClass * klass) {
	xnoise_mpris_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseMprisPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_xnoise_mpris_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_xnoise_mpris_set_property;
	G_OBJECT_CLASS (klass)->finalize = xnoise_mpris_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_XN, "xn");
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_OWNER, "owner");
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_NAME, "name");
}


static void xnoise_mpris_xnoise_iplugin_interface_init (XnoiseIPluginIface * iface) {
	xnoise_mpris_xnoise_iplugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->init = (gboolean (*)(XnoiseIPlugin*)) xnoise_mpris_real_init;
	iface->uninit = (void (*)(XnoiseIPlugin*)) xnoise_mpris_real_uninit;
	iface->get_settings_widget = (GtkWidget* (*)(XnoiseIPlugin*)) xnoise_mpris_real_get_settings_widget;
	iface->has_settings_widget = (gboolean (*)(XnoiseIPlugin*)) xnoise_mpris_real_has_settings_widget;
	iface->get_xn = xnoise_mpris_real_get_xn;
	iface->set_xn = xnoise_mpris_real_set_xn;
	iface->get_owner = xnoise_mpris_real_get_owner;
	iface->set_owner = xnoise_mpris_real_set_owner;
	iface->get_name = xnoise_mpris_real_get_name;
}


static void xnoise_mpris_instance_init (XnoiseMpris * self) {
	self->priv = XNOISE_MPRIS_GET_PRIVATE (self);
	self->player = NULL;
	self->root = NULL;
}


static void xnoise_mpris_finalize (GObject* obj) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (obj);
	_g_object_unref0 (self->priv->_xn);
	_g_object_unref0 (self->player);
	_g_object_unref0 (self->root);
	G_OBJECT_CLASS (xnoise_mpris_parent_class)->finalize (obj);
}


GType xnoise_mpris_get_type (void) {
	return xnoise_mpris_type_id;
}


GType xnoise_mpris_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseMprisClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_mpris_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseMpris), 0, (GInstanceInitFunc) xnoise_mpris_instance_init, NULL };
	static const GInterfaceInfo xnoise_iplugin_info = { (GInterfaceInitFunc) xnoise_mpris_xnoise_iplugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	xnoise_mpris_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseMpris", &g_define_type_info, 0);
	g_type_module_add_interface (module, xnoise_mpris_type_id, XNOISE_TYPE_IPLUGIN, &xnoise_iplugin_info);
	return xnoise_mpris_type_id;
}


static void _vala_xnoise_mpris_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (object);
	switch (property_id) {
		case XNOISE_MPRIS_XN:
		g_value_set_object (value, xnoise_iplugin_get_xn ((XnoiseIPlugin*) self));
		break;
		case XNOISE_MPRIS_OWNER:
		g_value_set_object (value, xnoise_iplugin_get_owner ((XnoiseIPlugin*) self));
		break;
		case XNOISE_MPRIS_NAME:
		g_value_set_string (value, xnoise_iplugin_get_name ((XnoiseIPlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_xnoise_mpris_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (object);
	switch (property_id) {
		case XNOISE_MPRIS_XN:
		xnoise_iplugin_set_xn ((XnoiseIPlugin*) self, g_value_get_object (value));
		break;
		case XNOISE_MPRIS_OWNER:
		xnoise_iplugin_set_owner ((XnoiseIPlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


MprisRoot* mpris_root_construct (GType object_type) {
	MprisRoot * self = NULL;
	XnoiseMain* _tmp0_ = NULL;
	self = (MprisRoot*) g_object_new (object_type, NULL);
	_tmp0_ = xnoise_main_get_instance ();
	self->priv->xn = _tmp0_;
	return self;
}


MprisRoot* mpris_root_new (void) {
	return mpris_root_construct (TYPE_MPRIS_ROOT);
}


void mpris_root_Quit (MprisRoot* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_quit (self->priv->xn);
}


void mpris_root_Raise (MprisRoot* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_window_show_window (self->priv->xn->main_window);
}


gboolean mpris_root_get_CanQuit (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_root_get_CanRaise (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_root_get_HasTrackList (MprisRoot* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = FALSE;
	return result;
}


gchar* mpris_root_get_DesktopEntry (MprisRoot* self) {
	gchar* result;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("xnoise");
	result = _tmp0_;
	return result;
}


gchar* mpris_root_get_Identity (MprisRoot* self) {
	gchar* result;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("xnoise media player");
	result = _tmp0_;
	return result;
}


gchar** mpris_root_get_SupportedUriSchemes (MprisRoot* self, int* result_length1) {
	gchar** result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_ = NULL;
	gchar** sa;
	gint sa_length1;
	gint _sa_size_;
	gchar** _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("http");
	_tmp1_ = g_strdup ("file");
	_tmp2_ = g_strdup ("https");
	_tmp3_ = g_strdup ("ftp");
	_tmp4_ = g_new0 (gchar*, 4 + 1);
	_tmp4_[0] = _tmp0_;
	_tmp4_[1] = _tmp1_;
	_tmp4_[2] = _tmp2_;
	_tmp4_[3] = _tmp3_;
	sa = _tmp4_;
	sa_length1 = 4;
	_sa_size_ = 4;
	_tmp5_ = sa;
	*result_length1 = sa_length1;
	result = _tmp5_;
	return result;
}


gchar** mpris_root_get_SupportedMimeTypes (MprisRoot* self, int* result_length1) {
	gchar** result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar** _tmp45_ = NULL;
	gchar** sa;
	gint sa_length1;
	gint _sa_size_;
	gchar** _tmp46_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("application/x-ogg");
	_tmp1_ = g_strdup ("application/ogg");
	_tmp2_ = g_strdup ("video/3gpp");
	_tmp3_ = g_strdup ("video/avi");
	_tmp4_ = g_strdup ("video/dv");
	_tmp5_ = g_strdup ("video/fli");
	_tmp6_ = g_strdup ("video/flv");
	_tmp7_ = g_strdup ("video/mp4");
	_tmp8_ = g_strdup ("video/mp4v-es");
	_tmp9_ = g_strdup ("video/mpeg");
	_tmp10_ = g_strdup ("video/msvideo");
	_tmp11_ = g_strdup ("video/ogg");
	_tmp12_ = g_strdup ("video/quicktime");
	_tmp13_ = g_strdup ("video/vivo");
	_tmp14_ = g_strdup ("video/vnd.divx");
	_tmp15_ = g_strdup ("video/vnd.vivo");
	_tmp16_ = g_strdup ("video/x-anim");
	_tmp17_ = g_strdup ("video/x-avi");
	_tmp18_ = g_strdup ("video/x-flc");
	_tmp19_ = g_strdup ("video/x-fli");
	_tmp20_ = g_strdup ("video/x-flic");
	_tmp21_ = g_strdup ("video/x-flv");
	_tmp22_ = g_strdup ("video/x-m4v");
	_tmp23_ = g_strdup ("video/x-matroska");
	_tmp24_ = g_strdup ("video/x-mpeg");
	_tmp25_ = g_strdup ("video/x-mpg");
	_tmp26_ = g_strdup ("video/x-ms-asf");
	_tmp27_ = g_strdup ("video/x-msvideo");
	_tmp28_ = g_strdup ("video/x-ms-wm");
	_tmp29_ = g_strdup ("video/x-ms-wmv");
	_tmp30_ = g_strdup ("video/x-ms-wmx");
	_tmp31_ = g_strdup ("video/x-ms-wvx");
	_tmp32_ = g_strdup ("video/x-nsv");
	_tmp33_ = g_strdup ("video/x-ogm+ogg");
	_tmp34_ = g_strdup ("video/x-theora");
	_tmp35_ = g_strdup ("video/x-theora+ogg");
	_tmp36_ = g_strdup ("audio/x-vorbis+ogg");
	_tmp37_ = g_strdup ("audio/x-scpls");
	_tmp38_ = g_strdup ("audio/x-mp3");
	_tmp39_ = g_strdup ("audio/x-mpeg");
	_tmp40_ = g_strdup ("audio/mpeg");
	_tmp41_ = g_strdup ("audio/x-mpegurl");
	_tmp42_ = g_strdup ("audio/x-flac");
	_tmp43_ = g_strdup ("x-content/audio-cdda");
	_tmp44_ = g_strdup ("x-content/audio-player");
	_tmp45_ = g_new0 (gchar*, 45 + 1);
	_tmp45_[0] = _tmp0_;
	_tmp45_[1] = _tmp1_;
	_tmp45_[2] = _tmp2_;
	_tmp45_[3] = _tmp3_;
	_tmp45_[4] = _tmp4_;
	_tmp45_[5] = _tmp5_;
	_tmp45_[6] = _tmp6_;
	_tmp45_[7] = _tmp7_;
	_tmp45_[8] = _tmp8_;
	_tmp45_[9] = _tmp9_;
	_tmp45_[10] = _tmp10_;
	_tmp45_[11] = _tmp11_;
	_tmp45_[12] = _tmp12_;
	_tmp45_[13] = _tmp13_;
	_tmp45_[14] = _tmp14_;
	_tmp45_[15] = _tmp15_;
	_tmp45_[16] = _tmp16_;
	_tmp45_[17] = _tmp17_;
	_tmp45_[18] = _tmp18_;
	_tmp45_[19] = _tmp19_;
	_tmp45_[20] = _tmp20_;
	_tmp45_[21] = _tmp21_;
	_tmp45_[22] = _tmp22_;
	_tmp45_[23] = _tmp23_;
	_tmp45_[24] = _tmp24_;
	_tmp45_[25] = _tmp25_;
	_tmp45_[26] = _tmp26_;
	_tmp45_[27] = _tmp27_;
	_tmp45_[28] = _tmp28_;
	_tmp45_[29] = _tmp29_;
	_tmp45_[30] = _tmp30_;
	_tmp45_[31] = _tmp31_;
	_tmp45_[32] = _tmp32_;
	_tmp45_[33] = _tmp33_;
	_tmp45_[34] = _tmp34_;
	_tmp45_[35] = _tmp35_;
	_tmp45_[36] = _tmp36_;
	_tmp45_[37] = _tmp37_;
	_tmp45_[38] = _tmp38_;
	_tmp45_[39] = _tmp39_;
	_tmp45_[40] = _tmp40_;
	_tmp45_[41] = _tmp41_;
	_tmp45_[42] = _tmp42_;
	_tmp45_[43] = _tmp43_;
	_tmp45_[44] = _tmp44_;
	sa = _tmp45_;
	sa_length1 = 45;
	_sa_size_ = 45;
	_tmp46_ = sa;
	*result_length1 = sa_length1;
	result = _tmp46_;
	return result;
}


static void mpris_root_class_init (MprisRootClass * klass) {
	mpris_root_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MprisRootPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_mpris_root_get_property;
	G_OBJECT_CLASS (klass)->finalize = mpris_root_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_CAN_QUIT, g_param_spec_boolean ("CanQuit", "CanQuit", "CanQuit", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_CAN_RAISE, g_param_spec_boolean ("CanRaise", "CanRaise", "CanRaise", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_HAS_TRACK_LIST, g_param_spec_boolean ("HasTrackList", "HasTrackList", "HasTrackList", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_DESKTOP_ENTRY, g_param_spec_string ("DesktopEntry", "DesktopEntry", "DesktopEntry", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_IDENTITY, g_param_spec_string ("Identity", "Identity", "Identity", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_SUPPORTED_URI_SCHEMES, g_param_spec_boxed ("SupportedUriSchemes", "SupportedUriSchemes", "SupportedUriSchemes", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_SUPPORTED_MIME_TYPES, g_param_spec_boxed ("SupportedMimeTypes", "SupportedMimeTypes", "SupportedMimeTypes", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void mpris_root_instance_init (MprisRoot * self) {
	self->priv = MPRIS_ROOT_GET_PRIVATE (self);
}


static void mpris_root_finalize (GObject* obj) {
	MprisRoot * self;
	self = MPRIS_ROOT (obj);
	G_OBJECT_CLASS (mpris_root_parent_class)->finalize (obj);
}


GType mpris_root_get_type (void) {
	return mpris_root_type_id;
}


GType mpris_root_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisRoot), 0, (GInstanceInitFunc) mpris_root_instance_init, NULL };
	mpris_root_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisRoot", &g_define_type_info, 0);
	g_type_set_qdata (mpris_root_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_root_register_object);
	return mpris_root_type_id;
}


static void _vala_mpris_root_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MprisRoot * self;
	int length;
	self = MPRIS_ROOT (object);
	switch (property_id) {
		case MPRIS_ROOT_CAN_QUIT:
		g_value_set_boolean (value, mpris_root_get_CanQuit (self));
		break;
		case MPRIS_ROOT_CAN_RAISE:
		g_value_set_boolean (value, mpris_root_get_CanRaise (self));
		break;
		case MPRIS_ROOT_HAS_TRACK_LIST:
		g_value_set_boolean (value, mpris_root_get_HasTrackList (self));
		break;
		case MPRIS_ROOT_DESKTOP_ENTRY:
		g_value_take_string (value, mpris_root_get_DesktopEntry (self));
		break;
		case MPRIS_ROOT_IDENTITY:
		g_value_take_string (value, mpris_root_get_Identity (self));
		break;
		case MPRIS_ROOT_SUPPORTED_URI_SCHEMES:
		g_value_take_boxed (value, mpris_root_get_SupportedUriSchemes (self, &length));
		break;
		case MPRIS_ROOT_SUPPORTED_MIME_TYPES:
		g_value_take_boxed (value, mpris_root_get_SupportedMimeTypes (self, &length));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _dbus_mpris_root_Quit (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_root_Quit (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_root_Raise (MprisRoot* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_root_Raise (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void mpris_root_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Quit") == 0) {
		_dbus_mpris_root_Quit (object, parameters, invocation);
	} else if (strcmp (method_name, "Raise") == 0) {
		_dbus_mpris_root_Raise (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_mpris_root_get_CanQuit (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_CanQuit (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_CanRaise (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_CanRaise (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_HasTrackList (MprisRoot* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_HasTrackList (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_DesktopEntry (MprisRoot* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_root_get_DesktopEntry (self);
	_reply = g_variant_new_string (result);
	_g_free0 ( result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_Identity (MprisRoot* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_root_get_Identity (self);
	_reply = g_variant_new_string (result);
	_g_free0 ( result);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_SupportedUriSchemes (MprisRoot* self) {
	gchar** result;
	int result_length1;
	gchar** _tmp0_;
	GVariantBuilder _tmp1_;
	int _tmp2_;
	GVariant* _reply;
	result = mpris_root_get_SupportedUriSchemes (self, &result_length1);
	_tmp0_ = result;
	g_variant_builder_init (&_tmp1_, G_VARIANT_TYPE ("as"));
	for (_tmp2_ = 0; _tmp2_ < result_length1; _tmp2_++) {
		g_variant_builder_add_value (&_tmp1_, g_variant_new_string (*_tmp0_));
		_tmp0_++;
	}
	_reply = g_variant_builder_end (&_tmp1_);
	 result = (_vala_array_free ( result,  result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant* _dbus_mpris_root_get_SupportedMimeTypes (MprisRoot* self) {
	gchar** result;
	int result_length1;
	gchar** _tmp3_;
	GVariantBuilder _tmp4_;
	int _tmp5_;
	GVariant* _reply;
	result = mpris_root_get_SupportedMimeTypes (self, &result_length1);
	_tmp3_ = result;
	g_variant_builder_init (&_tmp4_, G_VARIANT_TYPE ("as"));
	for (_tmp5_ = 0; _tmp5_ < result_length1; _tmp5_++) {
		g_variant_builder_add_value (&_tmp4_, g_variant_new_string (*_tmp3_));
		_tmp3_++;
	}
	_reply = g_variant_builder_end (&_tmp4_);
	 result = (_vala_array_free ( result,  result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant* mpris_root_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "CanQuit") == 0) {
		return _dbus_mpris_root_get_CanQuit (object);
	} else if (strcmp (property_name, "CanRaise") == 0) {
		return _dbus_mpris_root_get_CanRaise (object);
	} else if (strcmp (property_name, "HasTrackList") == 0) {
		return _dbus_mpris_root_get_HasTrackList (object);
	} else if (strcmp (property_name, "DesktopEntry") == 0) {
		return _dbus_mpris_root_get_DesktopEntry (object);
	} else if (strcmp (property_name, "Identity") == 0) {
		return _dbus_mpris_root_get_Identity (object);
	} else if (strcmp (property_name, "SupportedUriSchemes") == 0) {
		return _dbus_mpris_root_get_SupportedUriSchemes (object);
	} else if (strcmp (property_name, "SupportedMimeTypes") == 0) {
		return _dbus_mpris_root_get_SupportedMimeTypes (object);
	}
	return NULL;
}


static gboolean mpris_root_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint mpris_root_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_root_dbus_interface_info), &_mpris_root_dbus_interface_vtable, data, _mpris_root_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _mpris_root_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static GType mpris_player_direction_get_type (void) {
	static volatile gsize mpris_player_direction_type_id__volatile = 0;
	if (g_once_init_enter (&mpris_player_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{MPRIS_PLAYER_DIRECTION_NEXT, "MPRIS_PLAYER_DIRECTION_NEXT", "next"}, {MPRIS_PLAYER_DIRECTION_PREVIOUS, "MPRIS_PLAYER_DIRECTION_PREVIOUS", "previous"}, {MPRIS_PLAYER_DIRECTION_STOP, "MPRIS_PLAYER_DIRECTION_STOP", "stop"}, {0, NULL, NULL}};
		GType mpris_player_direction_type_id;
		mpris_player_direction_type_id = g_enum_register_static ("MprisPlayerDirection", values);
		g_once_init_leave (&mpris_player_direction_type_id__volatile, mpris_player_direction_type_id);
	}
	return mpris_player_direction_type_id__volatile;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_variant_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}


static GVariant* _variant_new1 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new2 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static gboolean _lambda1_ (MprisPlayer* self) {
	gboolean result = FALSE;
	GVariant* valx;
	valx = _variant_new2 ("xnoise");
	mpris_player_queue_property_for_notification (self, "DesktopEntry", valx);
	result = FALSE;
	_g_variant_unref0 (valx);
	return result;
}


static gboolean __lambda1__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda1_ (self);
	return result;
}


static gboolean _lambda0_ (MprisPlayer* self) {
	gboolean result = FALSE;
	GVariant* val;
	val = _variant_new1 ("dummy");
	mpris_player_queue_property_for_notification (self, "DesktopEntry", val);
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, __lambda1__gsource_func, g_object_ref (self), g_object_unref);
	result = FALSE;
	_g_variant_unref0 (val);
	return result;
}


static gboolean __lambda0__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda0_ (self);
	return result;
}


static GVariant* _variant_new3 (gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void _lambda2_ (GObject* s, GParamSpec* p, MprisPlayer* self) {
	gchar* _tmp0_ = NULL;
	GVariant* variant;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = mpris_player_get_PlaybackStatus (self);
	variant = _variant_new3 (_tmp0_);
	mpris_player_queue_property_for_notification (self, "PlaybackStatus", variant);
	_g_variant_unref0 (variant);
}


static void __lambda2__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_lambda2_ (_sender, pspec, self);
}


static void _mpris_player_on_tag_changed_xnoise_global_access_tag_changed (XnoiseGlobalAccess* _sender, gchar** newuri, const gchar* tagname, const gchar* tagvalue, gpointer self) {
	mpris_player_on_tag_changed (self, _sender, newuri, tagname, tagvalue);
}


static GVariant* _variant_new4 (gdouble value) {
	return g_variant_ref_sink (g_variant_new_double (value));
}


static void _lambda4_ (MprisPlayer* self) {
	gdouble _tmp0_;
	GVariant* variant;
	_tmp0_ = xnoise_gst_player_get_volume (self->priv->xn->gPl);
	variant = _variant_new4 (_tmp0_);
	mpris_player_queue_property_for_notification (self, "Volume", variant);
	_g_variant_unref0 (variant);
}


static void __lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_lambda4_ (self);
}


static GVariant* _variant_new5 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new6 (gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new7 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void _lambda5_ (MprisPlayer* self) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* s;
	_tmp0_ = xnoise_global_access_get_image_path_large (xnoise_global);
	_tmp1_ = g_strdup (_tmp0_);
	s = _tmp1_;
	if (s == NULL) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("mpris:artUrl");
		g_hash_table_insert (self->priv->_metadata, _tmp2_, _variant_new5 (""));
	} else {
		GFile* _tmp3_ = NULL;
		GFile* f;
		_tmp3_ = g_file_new_for_commandline_arg (s);
		f = _tmp3_;
		if (f != NULL) {
			gchar* _tmp4_;
			gchar* _tmp5_ = NULL;
			_tmp4_ = g_strdup ("mpris:artUrl");
			_tmp5_ = g_file_get_uri (f);
			g_hash_table_insert (self->priv->_metadata, _tmp4_, _variant_new6 (_tmp5_));
		} else {
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("mpris:artUrl");
			g_hash_table_insert (self->priv->_metadata, _tmp6_, _variant_new7 (""));
		}
		_g_object_unref0 (f);
	}
	mpris_player_trigger_metadata_update (self);
	_g_free0 (s);
}


static void __lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_lambda5_ (self);
}


static GVariant* _variant_new8 (gint64 value) {
	return g_variant_ref_sink (g_variant_new_int64 (value));
}


static gint64 _variant_get9 (GVariant* value) {
	return g_variant_get_int64 (value);
}


static GVariant* _variant_new10 (gint64 value) {
	return g_variant_ref_sink (g_variant_new_int64 (value));
}


static void _lambda6_ (MprisPlayer* self) {
	gconstpointer _tmp0_ = NULL;
	gconstpointer _tmp2_ = NULL;
	gint64 _tmp3_;
	_tmp0_ = g_hash_table_lookup (self->priv->_metadata, "mpris:length");
	if (((GVariant*) _tmp0_) == NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("mpris:length");
		g_hash_table_insert (self->priv->_metadata, _tmp1_, _variant_new8 ((gint64) 0));
	}
	_tmp2_ = g_hash_table_lookup (self->priv->_metadata, "mpris:length");
	_tmp3_ = xnoise_gst_player_get_length_time (self->priv->xn->gPl);
	if (_variant_get9 ((GVariant*) _tmp2_) != (((gint64) _tmp3_) / 1000)) {
		gchar* _tmp4_;
		gint64 _tmp5_;
		_tmp4_ = g_strdup ("mpris:length");
		_tmp5_ = xnoise_gst_player_get_length_time (self->priv->xn->gPl);
		g_hash_table_insert (self->priv->_metadata, _tmp4_, _variant_new10 (((gint64) _tmp5_) / 1000));
		mpris_player_trigger_metadata_update (self);
	}
}


static void __lambda6__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_lambda6_ (self);
}


MprisPlayer* mpris_player_construct (GType object_type, GDBusConnection* conn) {
	MprisPlayer * self = NULL;
	XnoiseMain* _tmp0_ = NULL;
	g_return_val_if_fail (conn != NULL, NULL);
	self = (MprisPlayer*) g_object_new (object_type, NULL);
	self->priv->conn = conn;
	_tmp0_ = xnoise_main_get_instance ();
	self->priv->xn = _tmp0_;
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, __lambda0__gsource_func, g_object_ref (self), g_object_unref);
	g_signal_connect_object ((GObject*) xnoise_global, "notify::player-state", (GCallback) __lambda2__g_object_notify, self, 0);
	g_signal_connect_object (xnoise_global, "tag-changed", (GCallback) _mpris_player_on_tag_changed_xnoise_global_access_tag_changed, self, 0);
	g_signal_connect_object ((GObject*) self->priv->xn->gPl, "notify::volume", (GCallback) __lambda4__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) xnoise_global, "notify::image-path-large", (GCallback) __lambda5__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self->priv->xn->gPl, "notify::length-time", (GCallback) __lambda6__g_object_notify, self, 0);
	return self;
}


MprisPlayer* mpris_player_new (GDBusConnection* conn) {
	return mpris_player_construct (TYPE_MPRIS_PLAYER, conn);
}


static GVariant* _variant_new11 (GHashTable* value) {
	GVariantBuilder _tmp0_;
	GHashTableIter _tmp1_;
	gpointer _tmp2_;
	gpointer _tmp3_;
	g_hash_table_iter_init (&_tmp1_, value);
	g_variant_builder_init (&_tmp0_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp1_, &_tmp2_, &_tmp3_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp2_;
		_value = (GVariant*) _tmp3_;
		g_variant_builder_add (&_tmp0_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp0_));
}


static gboolean _lambda3_ (MprisPlayer* self) {
	gboolean result = FALSE;
	GVariant* variant;
	variant = _variant_new11 (self->priv->_metadata);
	mpris_player_queue_property_for_notification (self, "Metadata", variant);
	self->priv->update_metadata_source = (guint) 0;
	result = FALSE;
	_g_variant_unref0 (variant);
	return result;
}


static gboolean __lambda3__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda3_ (self);
	return result;
}


static void mpris_player_trigger_metadata_update (MprisPlayer* self) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	if (self->priv->update_metadata_source != 0) {
		g_source_remove (self->priv->update_metadata_source);
	}
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, __lambda3__gsource_func, g_object_ref (self), g_object_unref);
	self->priv->update_metadata_source = _tmp0_;
}


static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static GVariant* _variant_new12 (gchar** value, gint value_length1) {
	gchar** _tmp5_;
	GVariantBuilder _tmp6_;
	int _tmp7_;
	_tmp5_ = value;
	g_variant_builder_init (&_tmp6_, G_VARIANT_TYPE ("as"));
	for (_tmp7_ = 0; _tmp7_ < value_length1; _tmp7_++) {
		g_variant_builder_add_value (&_tmp6_, g_variant_new_string (*_tmp5_));
		_tmp5_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp6_));
}


static GVariant* _variant_new13 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static GVariant* _variant_new14 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static GVariant* _variant_new15 (gchar** value, gint value_length1) {
	gchar** _tmp15_;
	GVariantBuilder _tmp16_;
	int _tmp17_;
	_tmp15_ = value;
	g_variant_builder_init (&_tmp16_, G_VARIANT_TYPE ("as"));
	for (_tmp17_ = 0; _tmp17_ < value_length1; _tmp17_++) {
		g_variant_builder_add_value (&_tmp16_, g_variant_new_string (*_tmp15_));
		_tmp15_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp16_));
}


static void mpris_player_on_tag_changed (MprisPlayer* self, XnoiseGlobalAccess* sender, gchar** newuri, const gchar* tagname, const gchar* tagvalue) {
	const gchar* _tmp0_;
	GQuark _tmp1_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	static GQuark _tmp1__label3 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	_tmp0_ = tagname;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("artist")))) {
		switch (0) {
			default:
			{
				gchar** _tmp2_ = NULL;
				gchar** sa;
				gint sa_length1;
				gint _sa_size_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				_tmp2_ = g_new0 (gchar*, 0 + 1);
				sa = _tmp2_;
				sa_length1 = 0;
				_sa_size_ = 0;
				if (tagvalue == NULL) {
					tagvalue = "";
				}
				_tmp3_ = g_strdup (tagvalue);
				_vala_array_add1 (&sa, &sa_length1, &_sa_size_, _tmp3_);
				_tmp4_ = g_strdup ("xesam:artist");
				g_hash_table_insert (self->priv->_metadata, _tmp4_, _variant_new12 (sa, sa_length1));
				sa = (_vala_array_free (sa, sa_length1, (GDestroyNotify) g_free), NULL);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("album")))) {
		switch (0) {
			default:
			{
				gchar* _tmp8_;
				gchar* s;
				gchar* _tmp9_;
				if (tagvalue == NULL) {
					tagvalue = "";
				}
				_tmp8_ = g_strdup (tagvalue);
				s = _tmp8_;
				_tmp9_ = g_strdup ("xesam:album");
				g_hash_table_insert (self->priv->_metadata, _tmp9_, _variant_new13 (s));
				_g_free0 (s);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("title")))) {
		switch (0) {
			default:
			{
				gchar* _tmp10_;
				gchar* s;
				gchar* _tmp11_;
				if (tagvalue == NULL) {
					tagvalue = "";
				}
				_tmp10_ = g_strdup (tagvalue);
				s = _tmp10_;
				_tmp11_ = g_strdup ("xesam:title");
				g_hash_table_insert (self->priv->_metadata, _tmp11_, _variant_new14 (s));
				_g_free0 (s);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label3) ? _tmp1__label3 : (_tmp1__label3 = g_quark_from_static_string ("genre")))) {
		switch (0) {
			default:
			{
				gchar** _tmp12_ = NULL;
				gchar** sa;
				gint sa_length1;
				gint _sa_size_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				if (tagvalue == NULL) {
					tagvalue = "";
				}
				_tmp12_ = g_new0 (gchar*, 0 + 1);
				sa = _tmp12_;
				sa_length1 = 0;
				_sa_size_ = 0;
				_tmp13_ = g_strdup (tagvalue);
				_vala_array_add2 (&sa, &sa_length1, &_sa_size_, _tmp13_);
				_tmp14_ = g_strdup ("xesam:genre");
				g_hash_table_insert (self->priv->_metadata, _tmp14_, _variant_new15 (sa, sa_length1));
				sa = (_vala_array_free (sa, sa_length1, (GDestroyNotify) g_free), NULL);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				return;
			}
		}
	}
	mpris_player_trigger_metadata_update (self);
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static gboolean mpris_player_send_property_change (MprisPlayer* self) {
	gboolean result = FALSE;
	GVariantBuilder* _tmp0_ = NULL;
	GVariantBuilder* builder;
	GVariantType* _tmp1_ = NULL;
	GVariantType* _tmp2_;
	GVariantBuilder* _tmp3_ = NULL;
	GVariantBuilder* _tmp4_;
	GVariantBuilder* invalidated_builder;
	GList* _tmp5_ = NULL;
	GVariant* _tmp9_ = NULL;
	GVariant* _tmp10_ = NULL;
	GVariant* _tmp11_ = NULL;
	GVariant** _tmp12_ = NULL;
	GVariant** arg_tuple;
	gint arg_tuple_length1;
	gint _arg_tuple_size_;
	GVariant* _tmp13_ = NULL;
	GVariant* args;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->changed_properties == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = g_variant_builder_new (G_VARIANT_TYPE_DICTIONARY);
	builder = _tmp0_;
	_tmp1_ = g_variant_type_new ("as");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_builder_new (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_variant_type_free0 (_tmp2_);
	invalidated_builder = _tmp4_;
	_tmp5_ = g_hash_table_get_keys (self->priv->changed_properties);
	{
		GList* name_collection;
		GList* name_it;
		name_collection = _tmp5_;
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
			gchar* _tmp6_;
			gchar* name;
			_tmp6_ = g_strdup ((const gchar*) name_it->data);
			name = _tmp6_;
			{
				gconstpointer _tmp7_ = NULL;
				GVariant* _tmp8_;
				GVariant* variant;
				_tmp7_ = g_hash_table_lookup (self->priv->changed_properties, name);
				_tmp8_ = _g_variant_ref0 ((GVariant*) _tmp7_);
				variant = _tmp8_;
				g_print ("%s changed\n", name);
				g_variant_builder_add (builder, "{sv}", name, variant, NULL);
				_g_variant_unref0 (variant);
				_g_free0 (name);
			}
		}
		_g_list_free0 (name_collection);
	}
	_g_hash_table_unref0 (self->priv->changed_properties);
	self->priv->changed_properties = NULL;
	_tmp9_ = g_variant_new ("s", MPRIS_PLAYER_INTERFACE_NAME, NULL);
	_tmp10_ = g_variant_builder_end (builder);
	_tmp11_ = g_variant_builder_end (invalidated_builder);
	_tmp12_ = g_new0 (GVariant*, 3 + 1);
	_tmp12_[0] = g_variant_ref_sink (_tmp9_);
	_tmp12_[1] = g_variant_ref_sink (_tmp10_);
	_tmp12_[2] = g_variant_ref_sink (_tmp11_);
	arg_tuple = _tmp12_;
	arg_tuple_length1 = 3;
	_arg_tuple_size_ = 3;
	_tmp13_ = g_variant_new_tuple (arg_tuple, arg_tuple_length1);
	args = g_variant_ref_sink (_tmp13_);
	g_dbus_connection_emit_signal (self->priv->conn, NULL, "/org/mpris/MediaPlayer2", "org.freedesktop.DBus.Properties", "PropertiesChanged", args, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch1_g_error;
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_print ("Error emmitting PropertiesChanged dbus signal: %s\n", e->message);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_variant_unref0 (args);
		arg_tuple = (_vala_array_free (arg_tuple, arg_tuple_length1, (GDestroyNotify) g_variant_unref), NULL);
		_g_variant_builder_unref0 (invalidated_builder);
		_g_variant_builder_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	self->priv->send_property_source = (guint) 0;
	result = FALSE;
	_g_variant_unref0 (args);
	arg_tuple = (_vala_array_free (arg_tuple, arg_tuple_length1, (GDestroyNotify) g_variant_unref), NULL);
	_g_variant_builder_unref0 (invalidated_builder);
	_g_variant_builder_unref0 (builder);
	return result;
}


static gboolean _mpris_player_send_property_change_gsource_func (gpointer self) {
	gboolean result;
	result = mpris_player_send_property_change (self);
	return result;
}


static void mpris_player_queue_property_for_notification (MprisPlayer* self, const gchar* property, GVariant* val) {
	gchar* _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (property != NULL);
	g_return_if_fail (val != NULL);
	if (self->priv->changed_properties == NULL) {
		GHashTable* _tmp0_ = NULL;
		_tmp0_ = g_hash_table_new_full (g_str_hash, g_str_equal, _g_free0_, _g_variant_unref0_);
		_g_hash_table_unref0 (self->priv->changed_properties);
		self->priv->changed_properties = _tmp0_;
	}
	_tmp1_ = g_strdup (property);
	_tmp2_ = _g_variant_ref0 (val);
	g_hash_table_insert (self->priv->changed_properties, _tmp1_, _tmp2_);
	if (self->priv->send_property_source == 0) {
		guint _tmp3_;
		_tmp3_ = g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _mpris_player_send_property_change_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->send_property_source = _tmp3_;
	}
}


void mpris_player_Next (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_global_access_next (xnoise_global);
}


void mpris_player_Previous (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_global_access_prev (xnoise_global);
}


void mpris_player_Pause (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_global_access_pause (xnoise_global);
}


void mpris_player_PlayPause (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_global_access_play (xnoise_global, TRUE);
}


void mpris_player_Stop (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_window_stop (self->priv->xn->main_window);
}


void mpris_player_Play (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_global_access_play (xnoise_global, FALSE);
}


void mpris_player_Seek (MprisPlayer* self, gint64 Offset) {
	g_return_if_fail (self != NULL);
	return;
}


void mpris_player_SetPosition (MprisPlayer* self, const gchar* dobj, gint64 Position) {
	gint64 _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dobj != NULL);
	_tmp0_ = xnoise_gst_player_get_length_time (self->priv->xn->gPl);
	xnoise_gst_player_set_gst_position (self->priv->xn->gPl, ((gdouble) Position) / (_tmp0_ / 1000.0));
}


void mpris_player_OpenUri (MprisPlayer* self, const gchar* Uri) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (Uri != NULL);
	return;
}


gchar* mpris_player_get_PlaybackStatus (MprisPlayer* self) {
	gchar* result;
	XnoisePlayerState _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xnoise_global_access_get_player_state (xnoise_global);
	switch (_tmp0_) {
		case XNOISE_PLAYER_STATE_STOPPED:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("Stopped");
			result = _tmp1_;
			return result;
		}
		case XNOISE_PLAYER_STATE_PLAYING:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("Playing");
			result = _tmp2_;
			return result;
		}
		case XNOISE_PLAYER_STATE_PAUSED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("Paused");
			result = _tmp3_;
			return result;
		}
		default:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Stopped");
			result = _tmp4_;
			return result;
		}
	}
}


gchar* mpris_player_get_LoopStatus (MprisPlayer* self) {
	gchar* result;
	XnoiseMainWindowPlayerRepeatMode _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xnoise_main_window_get_repeatState (self->priv->xn->main_window);
	switch (_tmp0_) {
		case XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_NOT_AT_ALL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("None");
			result = _tmp1_;
			return result;
		}
		case XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_SINGLE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("Track");
			result = _tmp2_;
			return result;
		}
		case XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_ALL:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("Playlist");
			result = _tmp3_;
			return result;
		}
		case XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_RANDOM:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Playlist");
			result = _tmp4_;
			return result;
		}
		default:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("Playlist");
			result = _tmp5_;
			return result;
		}
	}
}


static GVariant* _variant_new16 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


void mpris_player_set_LoopStatus (MprisPlayer* self, const gchar* value) {
	const gchar* _tmp0_;
	GQuark _tmp1_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	GVariant* variant;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("None")))) {
		switch (0) {
			default:
			{
				xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_NOT_AT_ALL);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("Track")))) {
		switch (0) {
			default:
			{
				xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_SINGLE);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("Playlist")))) {
		switch (0) {
			default:
			{
				xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_ALL);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_ALL);
				break;
			}
		}
	}
	variant = _variant_new16 (value);
	mpris_player_queue_property_for_notification (self, "LoopStatus", variant);
	_g_variant_unref0 (variant);
	g_object_notify ((GObject *) self, "LoopStatus");
}


gdouble mpris_player_get_Rate (MprisPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


void mpris_player_set_Rate (MprisPlayer* self, gdouble value) {
	g_return_if_fail (self != NULL);
	g_object_notify ((GObject *) self, "Rate");
}


gboolean mpris_player_get_Shuffle (MprisPlayer* self) {
	gboolean result;
	XnoiseMainWindowPlayerRepeatMode _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = xnoise_main_window_get_repeatState (self->priv->xn->main_window);
	if (_tmp0_ == XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_RANDOM) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static GVariant* _variant_new17 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


void mpris_player_set_Shuffle (MprisPlayer* self, gboolean value) {
	GVariant* variant;
	g_return_if_fail (self != NULL);
	if (value == TRUE) {
		XnoiseMainWindowPlayerRepeatMode _tmp0_;
		_tmp0_ = xnoise_main_window_get_repeatState (self->priv->xn->main_window);
		self->priv->buffer_repeat_state = _tmp0_;
		xnoise_main_window_set_repeatState (self->priv->xn->main_window, XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_RANDOM);
	} else {
		xnoise_main_window_set_repeatState (self->priv->xn->main_window, self->priv->buffer_repeat_state);
	}
	variant = _variant_new17 (value);
	mpris_player_queue_property_for_notification (self, "Shuffle", variant);
	_g_variant_unref0 (variant);
	g_object_notify ((GObject *) self, "Shuffle");
}


static GVariant* _variant_new18 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


GHashTable* mpris_player_get_Metadata (MprisPlayer* self) {
	GHashTable* result;
	GVariant* variant;
	gchar* _tmp0_;
	GVariant* _tmp1_;
	GHashTable* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	variant = _variant_new18 ("1");
	_tmp0_ = g_strdup ("mpris:trackid");
	_tmp1_ = _g_variant_ref0 (variant);
	g_hash_table_insert (self->priv->_metadata, _tmp0_, _tmp1_);
	_tmp2_ = _g_hash_table_ref0 (self->priv->_metadata);
	result = _tmp2_;
	_g_variant_unref0 (variant);
	return result;
}


gdouble mpris_player_get_Volume (MprisPlayer* self) {
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = xnoise_gst_player_get_volume (self->priv->xn->gPl);
	result = _tmp0_;
	return result;
}


void mpris_player_set_Volume (MprisPlayer* self, gdouble value) {
	g_return_if_fail (self != NULL);
	if (value < 0.0) {
		value = 0.0;
	}
	if (value > 1.0) {
		value = 1.0;
	}
	xnoise_gst_player_set_volume (self->priv->xn->gPl, value);
	g_object_notify ((GObject *) self, "Volume");
}


gint64 mpris_player_get_Position (MprisPlayer* self) {
	gint64 result;
	gint64 _tmp0_;
	gdouble _tmp1_;
	gdouble pos;
	gint64 _tmp2_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = xnoise_gst_player_get_length_time (self->priv->xn->gPl);
	if (_tmp0_ == 0) {
		result = (gint64) (-1);
		return result;
	}
	_tmp1_ = xnoise_gst_player_get_gst_position (self->priv->xn->gPl);
	pos = _tmp1_;
	_tmp2_ = xnoise_gst_player_get_length_time (self->priv->xn->gPl);
	result = (gint64) ((pos * _tmp2_) / 1000.0);
	return result;
}


gdouble mpris_player_get_MinimumRate (MprisPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


gdouble mpris_player_get_MaximumRate (MprisPlayer* self) {
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}


gboolean mpris_player_get_CanGoNext (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanGoPrevious (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanPlay (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanPause (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanSeek (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean mpris_player_get_CanControl (MprisPlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}


static void mpris_player_class_init (MprisPlayerClass * klass) {
	mpris_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MprisPlayerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_mpris_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mpris_player_set_property;
	G_OBJECT_CLASS (klass)->finalize = mpris_player_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_PLAYBACK_STATUS, g_param_spec_string ("PlaybackStatus", "PlaybackStatus", "PlaybackStatus", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_LOOP_STATUS, g_param_spec_string ("LoopStatus", "LoopStatus", "LoopStatus", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_RATE, g_param_spec_double ("Rate", "Rate", "Rate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_SHUFFLE, g_param_spec_boolean ("Shuffle", "Shuffle", "Shuffle", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_METADATA, g_param_spec_boxed ("Metadata", "Metadata", "Metadata", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_VOLUME, g_param_spec_double ("Volume", "Volume", "Volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_POSITION, g_param_spec_int64 ("Position", "Position", "Position", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_MINIMUM_RATE, g_param_spec_double ("MinimumRate", "MinimumRate", "MinimumRate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_MAXIMUM_RATE, g_param_spec_double ("MaximumRate", "MaximumRate", "MaximumRate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_GO_NEXT, g_param_spec_boolean ("CanGoNext", "CanGoNext", "CanGoNext", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_GO_PREVIOUS, g_param_spec_boolean ("CanGoPrevious", "CanGoPrevious", "CanGoPrevious", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_PLAY, g_param_spec_boolean ("CanPlay", "CanPlay", "CanPlay", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_PAUSE, g_param_spec_boolean ("CanPause", "CanPause", "CanPause", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_SEEK, g_param_spec_boolean ("CanSeek", "CanSeek", "CanSeek", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_CONTROL, g_param_spec_boolean ("CanControl", "CanControl", "CanControl", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("seeked", TYPE_MPRIS_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
}


static void mpris_player_instance_init (MprisPlayer * self) {
	GHashTable* _tmp0_ = NULL;
	self->priv = MPRIS_PLAYER_GET_PRIVATE (self);
	self->priv->send_property_source = (guint) 0;
	self->priv->update_metadata_source = (guint) 0;
	self->priv->changed_properties = NULL;
	self->priv->buffer_repeat_state = XNOISE_MAIN_WINDOW_PLAYER_REPEAT_MODE_NOT_AT_ALL;
	_tmp0_ = g_hash_table_new_full (g_str_hash, g_str_equal, _g_free0_, _g_variant_unref0_);
	self->priv->_metadata = _tmp0_;
}


static void mpris_player_finalize (GObject* obj) {
	MprisPlayer * self;
	self = MPRIS_PLAYER (obj);
	_g_hash_table_unref0 (self->priv->changed_properties);
	_g_hash_table_unref0 (self->priv->_metadata);
	G_OBJECT_CLASS (mpris_player_parent_class)->finalize (obj);
}


GType mpris_player_get_type (void) {
	return mpris_player_type_id;
}


GType mpris_player_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisPlayer), 0, (GInstanceInitFunc) mpris_player_instance_init, NULL };
	mpris_player_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisPlayer", &g_define_type_info, 0);
	g_type_set_qdata (mpris_player_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_player_register_object);
	return mpris_player_type_id;
}


static void _vala_mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MprisPlayer * self;
	self = MPRIS_PLAYER (object);
	switch (property_id) {
		case MPRIS_PLAYER_PLAYBACK_STATUS:
		g_value_take_string (value, mpris_player_get_PlaybackStatus (self));
		break;
		case MPRIS_PLAYER_LOOP_STATUS:
		g_value_take_string (value, mpris_player_get_LoopStatus (self));
		break;
		case MPRIS_PLAYER_RATE:
		g_value_set_double (value, mpris_player_get_Rate (self));
		break;
		case MPRIS_PLAYER_SHUFFLE:
		g_value_set_boolean (value, mpris_player_get_Shuffle (self));
		break;
		case MPRIS_PLAYER_METADATA:
		g_value_take_boxed (value, mpris_player_get_Metadata (self));
		break;
		case MPRIS_PLAYER_VOLUME:
		g_value_set_double (value, mpris_player_get_Volume (self));
		break;
		case MPRIS_PLAYER_POSITION:
		g_value_set_int64 (value, mpris_player_get_Position (self));
		break;
		case MPRIS_PLAYER_MINIMUM_RATE:
		g_value_set_double (value, mpris_player_get_MinimumRate (self));
		break;
		case MPRIS_PLAYER_MAXIMUM_RATE:
		g_value_set_double (value, mpris_player_get_MaximumRate (self));
		break;
		case MPRIS_PLAYER_CAN_GO_NEXT:
		g_value_set_boolean (value, mpris_player_get_CanGoNext (self));
		break;
		case MPRIS_PLAYER_CAN_GO_PREVIOUS:
		g_value_set_boolean (value, mpris_player_get_CanGoPrevious (self));
		break;
		case MPRIS_PLAYER_CAN_PLAY:
		g_value_set_boolean (value, mpris_player_get_CanPlay (self));
		break;
		case MPRIS_PLAYER_CAN_PAUSE:
		g_value_set_boolean (value, mpris_player_get_CanPause (self));
		break;
		case MPRIS_PLAYER_CAN_SEEK:
		g_value_set_boolean (value, mpris_player_get_CanSeek (self));
		break;
		case MPRIS_PLAYER_CAN_CONTROL:
		g_value_set_boolean (value, mpris_player_get_CanControl (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MprisPlayer * self;
	self = MPRIS_PLAYER (object);
	switch (property_id) {
		case MPRIS_PLAYER_LOOP_STATUS:
		mpris_player_set_LoopStatus (self, g_value_get_string (value));
		break;
		case MPRIS_PLAYER_RATE:
		mpris_player_set_Rate (self, g_value_get_double (value));
		break;
		case MPRIS_PLAYER_SHUFFLE:
		mpris_player_set_Shuffle (self, g_value_get_boolean (value));
		break;
		case MPRIS_PLAYER_VOLUME:
		mpris_player_set_Volume (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _dbus_mpris_player_Next (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Next (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Previous (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Previous (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Pause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Pause (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_PlayPause (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_PlayPause (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Stop (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Stop (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Play (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_Play (self);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_Seek (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint64 Offset = 0LL;
	GVariant* _tmp6_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	Offset = g_variant_get_int64 (_tmp6_);
	g_variant_unref (_tmp6_);
	mpris_player_Seek (self, Offset);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_SetPosition (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* dobj = NULL;
	GVariant* _tmp7_;
	gint64 Position = 0LL;
	GVariant* _tmp8_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	dobj = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	Position = g_variant_get_int64 (_tmp8_);
	g_variant_unref (_tmp8_);
	mpris_player_SetPosition (self, dobj, Position);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (dobj);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_OpenUri (MprisPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* Uri = NULL;
	GVariant* _tmp9_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	Uri = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	mpris_player_OpenUri (self, Uri);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (Uri);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Next") == 0) {
		_dbus_mpris_player_Next (object, parameters, invocation);
	} else if (strcmp (method_name, "Previous") == 0) {
		_dbus_mpris_player_Previous (object, parameters, invocation);
	} else if (strcmp (method_name, "Pause") == 0) {
		_dbus_mpris_player_Pause (object, parameters, invocation);
	} else if (strcmp (method_name, "PlayPause") == 0) {
		_dbus_mpris_player_PlayPause (object, parameters, invocation);
	} else if (strcmp (method_name, "Stop") == 0) {
		_dbus_mpris_player_Stop (object, parameters, invocation);
	} else if (strcmp (method_name, "Play") == 0) {
		_dbus_mpris_player_Play (object, parameters, invocation);
	} else if (strcmp (method_name, "Seek") == 0) {
		_dbus_mpris_player_Seek (object, parameters, invocation);
	} else if (strcmp (method_name, "SetPosition") == 0) {
		_dbus_mpris_player_SetPosition (object, parameters, invocation);
	} else if (strcmp (method_name, "OpenUri") == 0) {
		_dbus_mpris_player_OpenUri (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_mpris_player_get_PlaybackStatus (MprisPlayer* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_player_get_PlaybackStatus (self);
	_reply = g_variant_new_string (result);
	_g_free0 ( result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_LoopStatus (MprisPlayer* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_player_get_LoopStatus (self);
	_reply = g_variant_new_string (result);
	_g_free0 ( result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Rate (MprisPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_Rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Shuffle (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_Shuffle (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Metadata (MprisPlayer* self) {
	GHashTable* result;
	GVariantBuilder _tmp10_;
	GHashTableIter _tmp11_;
	gpointer _tmp12_;
	gpointer _tmp13_;
	GVariant* _reply;
	result = mpris_player_get_Metadata (self);
	g_hash_table_iter_init (&_tmp11_, result);
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp11_, &_tmp12_, &_tmp13_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp12_;
		_value = (GVariant*) _tmp13_;
		g_variant_builder_add (&_tmp10_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	_reply = g_variant_builder_end (&_tmp10_);
	_g_hash_table_unref0 ( result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Volume (MprisPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_Volume (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_Position (MprisPlayer* self) {
	gint64 result;
	GVariant* _reply;
	result = mpris_player_get_Position (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_MinimumRate (MprisPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_MinimumRate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_MaximumRate (MprisPlayer* self) {
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_MaximumRate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanGoNext (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanGoNext (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanGoPrevious (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanGoPrevious (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanPlay (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanPlay (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanPause (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanPause (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanSeek (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanSeek (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_CanControl (MprisPlayer* self) {
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_CanControl (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		return _dbus_mpris_player_get_PlaybackStatus (object);
	} else if (strcmp (property_name, "LoopStatus") == 0) {
		return _dbus_mpris_player_get_LoopStatus (object);
	} else if (strcmp (property_name, "Rate") == 0) {
		return _dbus_mpris_player_get_Rate (object);
	} else if (strcmp (property_name, "Shuffle") == 0) {
		return _dbus_mpris_player_get_Shuffle (object);
	} else if (strcmp (property_name, "Metadata") == 0) {
		return _dbus_mpris_player_get_Metadata (object);
	} else if (strcmp (property_name, "Volume") == 0) {
		return _dbus_mpris_player_get_Volume (object);
	} else if (strcmp (property_name, "Position") == 0) {
		return _dbus_mpris_player_get_Position (object);
	} else if (strcmp (property_name, "MinimumRate") == 0) {
		return _dbus_mpris_player_get_MinimumRate (object);
	} else if (strcmp (property_name, "MaximumRate") == 0) {
		return _dbus_mpris_player_get_MaximumRate (object);
	} else if (strcmp (property_name, "CanGoNext") == 0) {
		return _dbus_mpris_player_get_CanGoNext (object);
	} else if (strcmp (property_name, "CanGoPrevious") == 0) {
		return _dbus_mpris_player_get_CanGoPrevious (object);
	} else if (strcmp (property_name, "CanPlay") == 0) {
		return _dbus_mpris_player_get_CanPlay (object);
	} else if (strcmp (property_name, "CanPause") == 0) {
		return _dbus_mpris_player_get_CanPause (object);
	} else if (strcmp (property_name, "CanSeek") == 0) {
		return _dbus_mpris_player_get_CanSeek (object);
	} else if (strcmp (property_name, "CanControl") == 0) {
		return _dbus_mpris_player_get_CanControl (object);
	}
	return NULL;
}


static void _dbus_mpris_player_set_LoopStatus (MprisPlayer* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	mpris_player_set_LoopStatus (self, value);
	_g_free0 (value);
}


static void _dbus_mpris_player_set_Rate (MprisPlayer* self, GVariant* _value) {
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	mpris_player_set_Rate (self, value);
}


static void _dbus_mpris_player_set_Shuffle (MprisPlayer* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	mpris_player_set_Shuffle (self, value);
}


static void _dbus_mpris_player_set_Volume (MprisPlayer* self, GVariant* _value) {
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	mpris_player_set_Volume (self, value);
}


static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "LoopStatus") == 0) {
		_dbus_mpris_player_set_LoopStatus (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Rate") == 0) {
		_dbus_mpris_player_set_Rate (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Shuffle") == 0) {
		_dbus_mpris_player_set_Shuffle (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Volume") == 0) {
		_dbus_mpris_player_set_Volume (object, value);
		return TRUE;
	}
	return FALSE;
}


static void _dbus_mpris_player_seeked (GObject* _sender, gint64 Position, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int64 (Position));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.mpris.MediaPlayer2.Player", "Seeked", _arguments, NULL);
}


guint mpris_player_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_player_dbus_interface_info), &_mpris_player_dbus_interface_vtable, data, _mpris_player_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "seeked", (GCallback) _dbus_mpris_player_seeked, data);
	return result;
}


static void _mpris_player_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



